package com.engine.hostar.controller;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.hostar.service.KqDevService;
import com.engine.hostar.service.impl.KqDevServiceImpl;
import com.google.gson.Gson;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Application;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

public class KqDevController {
    public KqDevService getKqDevService(User user) {
        return ServiceUtil.getService(KqDevServiceImpl.class,user);
    }

    @POST
    @Path("/getKqType")
    @Produces(MediaType.APPLICATION_JSON)
    public String getKqType(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> params = ParamUtil.request2Map(request);
        Map<String, Object> resultDatas = getKqDevService(user).getKqType(params);
        return  new Gson().toJson(resultDatas);
    }

    @POST
    @Path("/getEndWorkDate")
    @Produces(MediaType.APPLICATION_JSON)
    public String getEndWorkDate(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> params = ParamUtil.request2Map(request);
        Map<String, Object> resultDatas = getKqDevService(user).getEndWorkDate(params);
        return  new Gson().toJson(resultDatas);
    }

    @POST
    @Path("/signDelete")
    @Produces(MediaType.APPLICATION_JSON)
    public String signDelete(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> params = ParamUtil.request2Map(request);
        Map<String, Object> resultDatas = getKqDevService(user).signDelete(params);
        return  new Gson().toJson(resultDatas);
    }

    @POST
    @Path("/updateCbInfo")
    @Produces(MediaType.APPLICATION_JSON)
    public String updateCbInfo(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> params = ParamUtil.request2Map(request);
        Map<String, Object> resultDatas = getKqDevService(user).updateCbInfo(params);
        return  new Gson().toJson(resultDatas);
    }

}